-------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------
---MAIN
-------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------

_AUTO_RELOAD_DEBUG = function() dialog_main() end

--define dialog, vb, vws & rnt
dialog = nil --placeholder for the dialog
vb = renoise.ViewBuilder() --ViewBuilder general
vws = vb.views --views general
rnt = renoise.tool() --tool general

title = " Custom-Sliders"
version = "Custom-Sliders v1.0 (build 1) for Renoise v3.1.1 ulneiz (Spain), 2018."

-------------------------------------------------------------------------------------------
--REQUIRE
-------------------------------------------------------------------------------------------
--require ("lua/xxx")
require ("lua/keyhandler")




-------------------------------------------------------------------------------------------
--FUNCTIONS
-------------------------------------------------------------------------------------------

--timer
function micro_cb_sliders()
  local song = renoise.song()
  if ( song.selected_note_column ) then
    --volume
    if ( song.selected_note_column.volume_value < 255 ) then
      vws["CUSTOM_VOL_SLIDER"].value = math.floor( ("%s"):format( song.selected_note_column.volume_value * 7 ) )
    end
  end
end
---
local micro_current_line
function micro_check_current_line_play()
  local song = renoise.song()
  local sli = song.selected_line_index
  if ( micro_current_line ~= sli ) then
    micro_current_line = sli
    micro_cb_sliders()
  else
    return
  end
  print("line",sli)
end
---
function micro_cb_active( bolean )
  if ( bolean == true ) then
    if not renoise.tool():has_timer( micro_check_current_line_play ) then
      renoise.tool():add_timer( micro_check_current_line_play, 5 )
    end
  else
    if renoise.tool():has_timer( micro_check_current_line_play ) then
      renoise.tool():remove_timer( micro_check_current_line_play )
    end
  end
end
---
CUSTOM_ACTIVE_SLIDERS = vb:row {
  vb:checkbox {
    id = "CUSTOM_CB_SLIDERS",
    value = false,
    notifier = function ( value ) micro_cb_active( value ) end
  }
}



-----------------------------------------------------------------------------------
--vol
function slider_value( number, fun )
  local num = math.floor( ("%s"):format( number/7 ) )
  local num_2 = math.floor( ("%s"):format( 1 + number/3.5 ) )
  print("num",num)
  local song = renoise.song()
  if ( song.selected_note_column ) then
    ---volume
    if ( fun == 1 ) then
      if ( num < 0 ) then
        song.selected_note_column.volume_value = 255
        vws["CUSTOM_VOL_BT"].text = ".."
      else 
        song.selected_note_column.volume_value = num
        vws["CUSTOM_VOL_BT"].text = ("%.2X"):format( num )
      end
      if not ( song.selected_track.volume_column_visible ) then
        song.selected_track.volume_column_visible = true
      end
    end
  end
end
---

--[[
function micro_active_btt_vol()
  renoise.tool():remove_timer( micro_active_btt_vol )
  print("x")
  vws["CUSTOM_VOL_BT"].active = true
end
---
function micro_timer_btt_vol(t)
  vws["CUSTOM_VOL_BT"].active = false
  renoise.tool():add_timer( micro_active_btt_vol, t )
end
]]

---
CUSTOM_VOL = vb:row { style = "plain", spacing = -1,
  vb:row { spacing = -3,
    vb:button {
      height = 19,
      width = 31,
      text ="..",
      notifier = function() vws["CUSTOM_VOL_SLIDER"].value = -1 end
    },
    vb:button {
      height = 19,
      width = 31,
      text ="7F",
      notifier = function() vws["CUSTOM_VOL_SLIDER"].value = 889 end
    }
  },
  vb:row { spacing = -919,
    vb:column { spacing = -21, margin = -1,
      vb:row { spacing = -26,
        vb:row {},
        vb:slider {
          id = "CUSTOM_VOL_SLIDER",
          height = 21,
          width = 947,
          min = -1,
          max = 889,
          value = 1,
          notifier = function(value) vws["CUSTOM_VOL_BT"].active = true vws["CUSTOM_VOL_BAR"].width = value+2  vws["CUSTOM_VOL_RW_WIDTH"].width = value+2  slider_value( value, 1 ) end
        }
      },    
      vb:row {
        style = "plain",
        height = 21,
        width = 923
      }
    },
    vb:row { spacing = -3,
      vb:column {
        id = "CUSTOM_VOL_RW_WIDTH",
        width = 1,
        vb:space { height = 5 },
        vb:button {
          id = "CUSTOM_VOL_BAR",
          active = false,
          height = 9,
          width = 1,
          color = { 120,120,000 },
        },
      },
      vb:button {
        id = "CUSTOM_VOL_BT",
        active = false,
        height = 19,
        width = 31,
        text = "..",
        color = { 090,090,000 },
        pressed = function() end,--function() micro_timer_btt_vol(20) end,
        notifier = function() vws["CUSTOM_VOL_BT"].active = false end,
        midi_mapping = "x"
      }
    }
  },
  vb:button {
    height = 19,
    width = 31,
    text ="[]",
    notifier = function() slider_value( vws["CUSTOM_VOL_SLIDER"].value, 1 ) end
  }
}



-------------------------------------------------------------------------------------------
--GUI
-------------------------------------------------------------------------------------------
--content
content = vb:column { margin = 5, spacing = 4,
  CUSTOM_ACTIVE_SLIDERS,
  CUSTOM_VOL
}




-------------------------------------------------------------------------------------------
--DIALOG_MAIN
-------------------------------------------------------------------------------------------
function dialog_main()
  --Avoid showing the same window several times!
  if ( dialog and dialog.visible ) then dialog:show() return end

  --Load dialog ( with "title name", content and key_handler )
  dialog = renoise.app():show_custom_dialog( title, content, key_handler )
  
  --reload all dialog main() in new song
  if not renoise.tool().app_new_document_observable:has_notifier( dialog_main ) then
    renoise.tool().app_new_document_observable:add_notifier( dialog_main )
  end
end



-------------------------------------------------------------------------------------------
-- ADD_MENU_ENTRY
-------------------------------------------------------------------------------------------
--main
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Custom-Sliders...",
  invoke = function() dialog_main() end
}

renoise.tool():add_menu_entry {
  name = "Pattern Editor:Custom-Sliders...",
  invoke = function() dialog_main() end
}
